/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Contents of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log


Revision 271 - (show annotations)
Fri Sep 9 18:21:14 2011 UTC (12 years, 7 months ago) by dpavlin
File MIME type: application/x-sh
File size: 5980 byte(s)
use new lxc-info 0.7.5 output for status
1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides: lxc-watchdog
4 # Required-Start: $remote_fs $named $network $time
5 # Required-Stop: $remote_fs $named $network
6 # Required-Start:
7 # Required-Stop:
8 # Default-Start: 2 3 4 5
9 # Default-Stop: 0 1 6
10 # Short-Description: Manage Linux Containers startup/shutdown
11 # Description: Uses clever inotify hack to monitor container's
12 # halt/reboot events watching /var/run/utmp
13 ### END INIT INFO
14
15 # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16 #
17 # based on Tony Risinger post to lxc-users mailing list
18 # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19 #
20 # Install with:
21 # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22 # update-rc.d lxc-watchdog defaults
23
24
25 which inotifywait >/dev/null || apt-get install inotify-tools
26
27
28 lxc_exists() {
29 name=$1
30
31 if [ ! -e /var/lib/lxc/$name/config ] ; then
32 echo "Usage: $0 name"
33 lxc_status
34 exit 1
35 fi
36 }
37
38
39 lxc_rootfs() {
40 grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41 }
42
43 lxc_hostname() {
44 inside=`cat $(lxc_rootfs $1)/etc/hostname`
45 config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46 echo "$config [$inside]";
47 }
48
49 lxc_ip() {
50 ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51 grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52 head -1 | \
53 sed -e 's/ *//g' -e 's/\/.*$//'
54 }
55
56 lxc_status() {
57 ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | while read name ; do
58 status=`lxc-info -n $name 2>/dev/null | grep state: | cut -d: -f2`
59 boot="-"
60 test -s /var/lib/lxc/$name/on_boot && boot="boot"
61 echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
62 done ) | column -t
63 }
64
65
66 cleanup_init_scripts() {
67 rootfs=$(lxc_rootfs $1)
68
69 ls \
70 $rootfs/etc/rc?.d/*checkroot* \
71 $rootfs/etc/rc?.d/*umountfs \
72 $rootfs/etc/rc?.d/*umountroot \
73 $rootfs/etc/rc?.d/*hwclock* \
74 $rootfs/etc/rc?.d/*udev* \
75 $rootfs/etc/rc?.d/*checkfs* \
76 2>/dev/null | xargs -i rm -v {}
77
78 echo $1 > $rootfs/etc/hostname
79 grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
80 }
81
82
83 setup_inittab() {
84 rootfs=$(lxc_rootfs $1)
85 remove=$2
86 add=$3
87
88 # let container respond to kill -SIGPWR
89 inittab=$rootfs/etc/inittab
90 if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
91 grep -v "$remove" ${inittab} > ${inittab}.new
92 echo $add >> ${inittab}.new
93 mv ${inittab}.new ${inittab}
94 echo "$inittab modified with $add"
95 fi
96 }
97
98
99 lxc_log() {
100 echo `date +%Y-%m-%dT%H:%M:%S` $*
101 }
102
103
104 lxc_kill() {
105 name=$1
106 sig=$2
107
108 init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
109 if [ -z "$init_pid" ] ; then
110 lxc-info -n $name
111 exit 1
112 fi
113 lxc_log "$name kill $sig $init_pid"
114 /bin/kill $sig $init_pid
115 }
116
117 lxc_stop() {
118 lxc_log "$name stop"
119 lxc_kill $name -SIGPWR
120 lxc-wait -n $name -s STOPPED
121 lxc_log "$name stoped"
122 # rm -f /var/lib/lxc/${name}/on_boot
123 }
124
125
126 lxc_start() {
127 name=$1
128 rootfs=$(lxc_rootfs $1)
129
130 if [ ! -e $rootfs ] ; then
131 echo "ERROR $name rootfs $rootfs not found"
132 return
133 fi
134
135 if ! lxc-info -n $name | grep RUNNING ; then
136 lxc_log "$name start"
137 dev=`df -P $rootfs | tail -1 | cut -d" " -f1`
138 mount $dev -o remount,rw # fix debian upgrade which remounts dir ro
139 lxc-start -n $name -o /tmp/${name}.log -d
140 lxc-wait -n $name -s RUNNING
141 lxc-info -n $name
142 test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
143 fi
144 }
145
146 lxc_watchdog() {
147 name=$1
148 rootfs=$(lxc_rootfs $1)
149 run=$rootfs/var/run
150 test -L $run && run=$rootfs/`readlink $run` # recent Debian have symlink to /run
151 cd $run || echo "can't cd watchdog into $run"
152
153 while true; do
154 tasks=`wc -l < /cgroup/${name}/tasks`
155 stop_on=1 # init
156 sulogins=`lxc-ps --name $name | grep sulogin | wc -l`
157 if [ "$sulogins" -gt 0 ] ; then
158 stop_on=`expr $stop_on + $sulogins`
159 fi
160
161 test -z "$tasks" && exit 1
162 if [ "$tasks" -eq $stop_on ]; then
163
164 runlevel="$(runlevel utmp)"
165 lxc_log "$name runlevel $runlevel"
166
167 case $runlevel in
168 N*)
169 # nothing for new boot state
170 ;;
171 ??0|unknown)
172 lxc_log "$name halt"
173 lxc-stop -n "${name}"
174 lxc-wait -n ${name} -s STOPPED
175 break
176 ;;
177 ??6)
178 lxc_log "$name reboot";
179 lxc-stop -n ${name}
180 lxc-wait -n ${name} -s STOPPED
181 lxc-start -d -n ${name} -o /tmp/${name}.log
182 ;;
183 *)
184 # make sure vps is still running
185 state="$(lxc-info -n "${name}" | sed -e 's/.* is //')"
186 [ "$state" = "RUNNING" ] || break
187 ;;
188 esac
189 else
190 lxc_log "$name $tasks tasks $sulogins console"
191 fi
192
193 # time of 5 minutes on it JUST IN CASE...
194 inotifywait -qqt 300 utmp
195 done
196
197 lxc_log "$name watchdog exited"
198
199 }
200
201
202 usage() {
203 echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
204 exit 3
205 }
206
207 command_on_lxc() {
208 command=$1
209 shift
210
211 echo "# $command $1"
212
213 case "$command" in
214
215 start)
216 lxc_exists $1
217 cleanup_init_scripts $1
218 setup_inittab $1 ":respawn:/sbin/getty.*tty1" "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
219 setup_inittab $1 "::power" "p0::powerfail:/sbin/init 0"
220 setup_inittab $1 "::ctrlaltdel" "p6::ctrlaltdel:/sbin/init 6"
221 lxc_start $1
222 # give container 5 seconds to start more than one process
223 ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
224 ;;
225 stop|halt)
226 lxc_exists $1
227 lxc_stop $1
228 ;;
229 reload|force-reload|restart|reboot)
230 lxc_kill $1 -SIGINT
231 ;;
232 watchdog)
233 lxc_watchdog $1
234 ;;
235 boot)
236 echo $1 > /var/lib/lxc/$1/on_boot
237 ;;
238 disable)
239 echo -n > /var/lib/lxc/$1/on_boot
240 ;;
241 *)
242 usage
243 ;;
244
245 esac
246
247 }
248
249 command=$1
250 test -z "$command" && usage
251 test "$command" = "status" && lxc_status && exit
252 shift
253
254 if [ -z "$1" ] ; then
255 ls /var/lib/lxc/*/on_boot | while read path ; do
256 name=`echo $path | cut -d/ -f5`
257 if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
258 command_on_lxc $command $name
259 else
260 echo "# skip $command $name"
261 fi
262 done
263 else
264 while [ ! -z "$1" ] ; do
265 command_on_lxc $command $1
266 shift
267 done
268 fi
269

Properties

Name Value
svn:executable *

  ViewVC Help
Powered by ViewVC 1.1.26